; //===================================================================================================
; // Mario Dash Level Editor
; // 
; // Updated 06.09.06
; // version who.knows.what
; //
; // * 02.14.06 *
; // Browser Modified
; // Loaded map starting at X position 1 instead of 0 fixed
; // File Open/Save now defaults to lvl directory
; // A/D to scroll controls added
; //
; // * 06.09.06 *
; // Window sizes more cleanly
; // Grid Toggle added to the view menu
; //===================================================================================================
Include "ftp.bb"

Const cnt_LOAD   = 1
Const cnt_NEW    = 2
Const cnt_SAVE   = 3
Const cnt_EXITED = 4
Const cnt_VTILE  = 5
Const cnt_INSTR  = 6
Const cnt_UPLOAD = 7, cntTIL1 = 8, cntTIL2 = 9, cntTIL3 = 10, cntCUST = 11
Const cnt_GRID = 20

Global Canvas, Parent, ed_Canvas, Toolbox = 0, ViewTile, MusicBox, MusicText, SaveBtn, gad_Clouds, gad_SColor
Global win_Level, gad_Browse, btn_Upload, req_R = 92, req_G = 148, req_B = 252
Global mnuMario, mnuIce, mnuCastle, ViewGrid, bGrid = True

Global img_b2 = LoadImage("gfx/b2.png", 1): MaskImage img_b2, 255, 0, 255
Global img_tiles = LoadAnimImage("gfx/tiles.png", 16, 16, 0, 75): MaskImage img_tiles, 255, 0, 255
Global b_Clouds = False

; // [Editor Publics]
Global c_Tile = 0, Map_X = 0, ed_scrX = 0, a_Canvas = 0, m1_Down = False, m2_Down = False, MapFile$ = "Untitled"

Dim Map$(5000, 13) ; Map Array
For i2 = 0 To 13: For i1 = 0 To 5000: Map$(i1, i2) = "x": Next: Next
LoadGUI(2)

AutoSuspend 1
CreateTimer 60
Repeat
Select WaitEvent()
	Case $803 ; Close Window
	FreeGadget EventSource()
	If EventSource() = Toolbox Then ; Update Menu
		Toolbox = 0
		SPanel = 0
		ed_Canvas = 0	
		UncheckMenu ViewTile: UpdateWindowMenu Parent: Toolbox = 0
	EndIf
	If EventSource() = Parent Then End ; Exit
	If EventSource() = MusicBox Then 
		SaveBtn = 0: MusicText = 0: gad_Clouds = 0
		MusicBox = 0
		Label = 0
		gad_SColor = 0
		SaveBtn = 0
	EndIf
	
	If EventSource() = cWin Then
		cWin = 0
		cOK = 0
		combo = 0
	EndIf
	
	If EventSource() = win_Level Then
		win_Level = 0
		gad_Browse = 0
		btn_Upload = 0
	EndIf
	
	Case $801 ; Attach Toolbox window to parent during move event
	If Toolbox <> 0 Then SetGadgetShape Toolbox, GadgetX(Parent) + 526, GadgetY(Parent), 176, 519
	
	Case $802 ; Prevent parent resizing in edit mode
	SetGadgetShape Parent, ClientWidth(Desktop())/2-263, ClientHeight(Desktop())/2-250, 526, 500
	If Toolbox <> 0 Then SetGadgetShape Toolbox, GadgetX(Parent) + 526, GadgetY(Parent), 176, 519 

	; Mouse Move Event (used for returning the active canvas)
	Case $203: a_Canvas = EventSource()
	Case $202
	If EventData() = 1 Then m1_Down = False ; LMB Toggle
	If EventData() = 2 Then m2_Down = False: m1_Down = False ; RMB Toggle
	
	Case $401  ; Gadget Events
	If EventSource() = SaveBtn Then
		tmp$ = TextFieldText(MusicText)
		tmp_File$ = RequestFile("Save Mario Dash Map File", "mdm", True, "lvl/*.mdm")
		If tmp$ = "" Then tmp$ = "null.mod"
		If tmp_File$ <> "" Then SaveMap(tmp_File$, tmp$)
		FreeGadget MusicBox
	EndIf
	
	If EventSource() = btn_Upload Then
		tmpR$ = RequestFile("Upload Level", "mdm", False, "lvl/*.mdm")
		If tmpR$ <> "" Then
			If FTP_Connect("s93151849.onlinehome.us", "u35755648md", "blitzer", "") Then
				DisableGadget btn_Upload
				SetStatusText win_Level, " Connected to level database [" + CurrentTime() + "]"
				bsPos% = 1
				For i = 1 To Len(tmpR$)
					If Mid(tmpR$, i, 1) = "\" And i > bsPos% Then bsPos% = i
				Next
				tmpR2$ = Right(tmpR$, Len(tmpR$) - bsPos%)
				CopyFile tmpR$, tmpR2$
				
				FTP_Put tmpR2$, 0, 0, 0
				SetStatusText win_Level, " File uploaded successfully [" + CurrentTime() + "]"
				
				DeleteFile tmpR2$
				EnableGadget btn_Upload
			EndIf
		EndIf
	ElseIf EventSource() = gad_SColor Then
		tmp5 = RequestColor(req_R, req_G, req_B)
		If tmp5 = 1 Then
			req_R = RequestedRed(): req_G = RequestedGreen(): req_B = RequestedBlue()
		EndIf

	ElseIf EventSource() = cOK Then ; Custom Tileset
		FreeImage img_b2: img_b2 = LoadImage("custom/" + GadgetItemText$(combo, SelectedGadgetItem(combo)) + "/" + "b2.png", 1): MaskImage img_b2, 255, 0, 255
		FreeImage img_tiles: img_tiles = LoadAnimImage("custom/" + GadgetItemText$(combo, SelectedGadgetItem(combo)) + "/" + "tiles.png", 16, 16, 0, 75): MaskImage img_tiles, 255, 0, 255
		FreeGadget cwin	
		UncheckMenu mnuMario: UncheckMenu mnuIce: UncheckMenu mnuCastle
		UpdateWindowMenu Parent	
	EndIf
	
	Case $201 ; Mouse Events
	If EventData() > 2 Then Goto StepOut2 ; Only register l/r clicks in edit mode
	If a_Canvas = Canvas Then ; Parent Canvas
		m1_Down = True
		If EventData() = 2 Then m2_down = True
	ElseIf a_Canvas = ed_Canvas Then ; Editor Toolwindow Canvas
		MX = MouseX(a_Canvas): MY = MouseY(a_Canvas): tmpX = 0: tmpY = 0: f = 0
		For i2 = 0 To (15 * 16) Step 16
			For i = 0 To (4 * 16) Step 16
				If MX > i And MX < i + 16 And MY > i2 And MY < i2 + 16 Then c_Tile = f
				If f < 75 Then f = f + 1
			Next
		Next
		ActivateGadget Canvas
	EndIf
	.StepOut2
		
	Case $1001 ; Menu Events
	Select EventData()
		Case cnt_LOAD ; Open Map and Editor
		tmp_File$ = RequestFile("Open Mario Dash Map File", "mdm", False, "lvl/*.mdm")
		If tmp_File$ <> "" Then FreeGadget Parent: LoadGUI(2): b_Edit = True: OpenMap(tmp_File$)
		
		Case cnt_NEW: For i2 = 0 To 13: For i1 = 0 To 5000: Map$(i1, i2) = "x": Next: Next: Map_X = 1
		
		Case cnt_OPEN ; Open Map
		tmp_File$ = RequestFile("Open Mario Dash Map File", "mdm", False, "lvl/*.mdm")
		If tmp_File$ <> "" Then OpenMap(tmp_File$)
		
		Case cnt_SAVE ; Save Map
		LoadGUI(4) ; Level Music
		
		Case cnt_EXITED: End ; Exit Editor
		
		Case cnt_GRID ; View Grid
		If MenuChecked(ViewGrid) = True Then
			UncheckMenu ViewGrid
			bGrid = False
		Else
			CheckMenu ViewGrid
			bGrid = True
		EndIf			
		UpdateWindowMenu Parent

		Case cntTIL1 ; Super Mario Tiles
		FreeImage img_b2: img_b2 = LoadImage("gfx/b2.png", 1): MaskImage img_b2, 255, 0, 255
		FreeImage img_tiles: img_tiles = LoadAnimImage("gfx/tiles.png", 16, 16, 0, 75): MaskImage img_tiles, 255, 0, 255
		CheckMenu mnuMario: UncheckMenu mnuIce: UncheckMenu mnuCastle
		UpdateWindowMenu Parent

		Case cntTIL2 ; Ice Climber Tiles
		FreeImage img_b2: img_b2 = LoadImage("gfx2/b2.png", 1): MaskImage img_b2, 255, 0, 255
		FreeImage img_tiles: img_tiles = LoadAnimImage("gfx2/tiles.png", 16, 16, 0, 75): MaskImage img_tiles, 255, 0, 255
		UncheckMenu mnuMario: CheckMenu mnuIce: UncheckMenu mnuCastle
		UpdateWindowMenu Parent
		 
		Case cntTIL3 ; Castlevania Tiles
		FreeImage img_b2: img_b2 = LoadImage("gfx3/b2.png", 1): MaskImage img_b2, 255, 0, 255
		FreeImage img_tiles: img_tiles = LoadAnimImage("gfx3/tiles.png", 16, 16, 0, 75): MaskImage img_tiles, 255, 0, 255
		UncheckMenu mnuMario: UncheckMenu mnuIce: CheckMenu mnuCastle
		UpdateWindowMenu Parent
	
		Case cnt_UPLOAD: LoadGUI(1) ; Load Level Database
		
		Case cnt_VTILE ; View Tile Window toggle
		If MenuChecked(ViewTile) Then 
			UncheckMenu(ViewTile): FreeGadget Toolbox: Toolbox = 0
		Else 
			CheckMenu(ViewTile): LoadGUI(3)				
		EndIf
		UpdateWindowMenu Parent
		
		Case cntCUST ; Custom Tileset
		Font = LoadFont("Verdana", 14, 0, 0, 0)
		cwin = CreateWindow("Custom Graphics", ClientWidth(Desktop())/2-78, ClientHeight(Desktop())/2-42, 157, 85, Parent, 1)
		cOK = CreateButton("OK", 0, 26, 150, 32, cwin, 1)
		SetGadgetFont cOK, Font
		combo = CreateComboBox(0, 0, 150, 100, cwin)
		SetGadgetFont combo, Font
		tdir = ReadDir("custom/"): tmp = 1
		Repeat
			tfile$ = NextFile$(tdir)
			If tfile$ = "" Then Exit
			If tfile$ <> "." And tfile$ <> ".." Then
				If FileType("custom/" + tfile$) = 2 Then AddGadgetItem combo, tfile$, tmp
				tmp = 0
			EndIf
		Forever	
		CloseDir tDir
		
		Case cnt_INSTR ; Editor Instructions
		Tmp$ = " Mario Dash Editor Instructions " + Chr$(10) +  Chr$(10) + "A / D or Left / Right to Scroll Map"
		Tmp$ = Tmp$ + Chr$(10) + "Left click to place tiles" + Chr$(10) + "Right click to erase tiles" + Chr$(10) + Chr$(10) + "* Start area must be clear of collision & enemies *" + Chr$(10) + Chr$(10) + "Tip: Hold left mouse button and scroll to speed draw"
		tmp$ = tmp$ + Chr$(10) + Chr$(10) + "Level will end when mario hits flag pole tiles"
		tmp$ = tmp$ + Chr$(10) + Chr$(10) + "If your level uses a custom tileset, please include"
		tmp$ = tmp$ + Chr$(10) + "the set's name in your map filename."
		tmp$ = tmp$ + Chr$(10) + "Ex: ZELDA_Level1.mdm"
		tmp$ = tmp$ + Chr$(10) + Chr$(10) + "Keep enemies one tile space apart if you want them"
		tmp$ = tmp$ + Chr$(10) + "to turn around when they hit an obstacle"
		
		
		
		Notify Tmp$
		
	End Select
	
	Case $4001: EditMode() ; Tick
			
End Select
Forever

; //===================================================================================================
; // [Load Map Function]
; //===================================================================================================
Function OpenMap(fname$)
For i2 = 0 To 13: For i1 = 0 To 5000: Map$(i1, i2) = "x": Next: Next
File = ReadFile(fname$)
tmp$ = ReadString(File)
tmp = ReadByte(File)
If tmp = 1 Then b_Clouds = True Else b_Clouds = False
req_R = ReadByte(File): req_G = ReadByte(File): req_B = ReadByte(File)

tmpBX = ReadShort(File)
For i2 = 0 To 13
	For i1 = 0 To tmpBX
		tmp = ReadByte(File)
		If tmp = 255 Then Map(i1, i2) = "x" Else Map(i1, i2) = Str(tmp)	
	Next
Next

CloseFile File: Map_X = 0
End Function

; //===================================================================================================
; // [Save Map Function]
; //===================================================================================================
Function SaveMap(fname$, mname$)
File = WriteFile(fname$)
WriteString File, mname$
If ButtonState(gad_Clouds) = True Then WriteByte File, 1 Else WriteByte File, 0
If req_R = 92 And req_G = 148 And req_B = 252 Then 
	WriteByte File, 92: WriteByte File, 148: WriteByte File, 252
Else
	;DebugLog req_R
	WriteByte File, req_R: WriteByte File, req_G: WriteByte File, req_B
EndIf

tmp_BX% = 0
For i2 = 0 To 13
	For i1 = 0 To 5000
		If Map$(i1, i2) <> "x" And i1 > tmp_BX Then tmp_BX = i1
	Next
Next

WriteShort File, tmp_BX ; Length

For i2 = 0 To 13
	For i1 = 0 To tmp_BX
		If Map$(i1, i2) = "x" Then tmp% = 255 Else tmp% = Int(Map$(i1, i2)) 
		WriteByte File, tmp%
	Next
Next
CloseFile File

End Function

; //===================================================================================================
; // [Edit Mode Function]
; //===================================================================================================
Function EditMode()
ClsColor req_R, req_G, req_B
Cls

If b_Clouds = True Then
	Viewport 0, 17, 256, 51: TileImage img_b2, ed_scrX/2, 17
	Viewport 0, 0, 256, 224
EndIf


Color 255, 255, 255 ; // Grid
If bGrid = True Then
	For i2 = 0 To 224 Step 16
		For i1 = 0 To 256 Step 16
			Rect i1, i2, 16, 16, 0
		Next
	Next
EndIf

tmpX = 0: tmpY = 0
For i2 = 0 To 13
	For i1 = Map_X To Map_X + 16
		If Map$(i1, i2) <> "x" Then DrawImage img_tiles, tmpX, tmpY, Int(Map$(i1, i2))
		tmpX = tmpX + 16
	Next
	tmpX = 0: tmpY = tmpY + 16
Next

If m1_Down = True Then
	MX = MouseX(a_Canvas): MY = MouseY(a_Canvas): tmpX = 0: tmpY = 0
	If m2_Down = True Then tmp_Tile$ = "x" Else tmp_Tile$ = Str(c_Tile) ; Eraser
	For i2 = 0 To 13
		For i1 = Map_X To Map_X + 16
			If MX > tmpX And MX < tmpX + 16 And MY > tmpY And MY < tmpY + 16 Then Map$(i1, i2) = tmp_Tile$
			tmpX = tmpX + 16
		Next
		tmpX = 0: tmpY = tmpY + 16
	Next
EndIf

If Not MenuChecked(ViewTile) Then Goto StepOut3

SetBuffer CanvasBuffer(ed_Canvas): ClsColor 0, 0, 255
Cls
f = 0
For i2 = 0 To (15 * 16) Step 16
	For i = 0 To (4 * 16) Step 16
		DrawImage img_tiles, i, i2, f
		If f < 74 Then f = f + 1 Else Goto StepOut4
	Next
Next
.StepOut4
Color 255, 255, 0: Text 1, 260, "Tile:"
DrawImage img_tiles, 42, 258, c_Tile
Text 1, 240, c_Tile

FlipCanvas ed_Canvas, 1
SetBuffer CanvasBuffer(Canvas)
.StepOut3
	
If (KeyDown(203) Or KeyDown(30)) And Map_X > 0 Then 
	ed_scrX = ed_scrX + 16: Map_X = Map_X - 1
Else If (KeyDown(205) Or KeyDown(32)) And Map_X < 4980 Then 
	ed_scrX = ed_scrX - 16: Map_X = Map_X + 1
EndIf

VWait 1: FlipCanvas Canvas, 1
End Function

; //===================================================================================================
; // [Load GUI Function]
; //===================================================================================================
Function LoadGUI(mode)
If mode = 1 Then ; Upload Level
	win_Level = CreateWindow("Mario Dash [Online Level Database]", ClientWidth(Desktop())/2-326, ClientHeight(Desktop())/2-265, 652, 530, Parent, 1 + 2 + 8)
	SetMinWindowSize win_Level, 652, 530
	gad_Browse = CreateHtmlView(1, 1, 643, 444, win_Level)           ; Browser
	SetGadgetLayout gad_Browse, 1, 2, 1, 2
	HtmlViewGo gad_Browse, "ftp://u35755648-levels:morninglory@eiksoft.com/"
	SetStatusText win_Level, " Welcome to the Level Database - Your level will appear within a week of your upload"
	Font = LoadFont("Verdana", 16, 0, 0, 0)
	btn_Upload = CreateButton("Upload Your Level", 226, 448, 200, 32, win_Level, 1)
	SetGadgetFont btn_Upload, Font
	SetGadgetLayout btn_Upload, 2, 2, 2, 2
	ActivateGadget gad_Browse
		
ElseIf mode = 2 Then ; Editor Windows
	StopChannel Channel
	AppTitle "Mario Dash"
	Parent = CreateWindow("Mario Dash [Level Editor]", -300, 0, 268, 274, 0, 1 + 4)
	hWnd = QueryObject(Parent, 1)
	icon = LoadIcon(hWnd, "task2.ico", 0)
	api_SetClassLong hwnd, -14, icon
	ret = api_GetWindowLong(hWnd, -16)
	ret = ret Or $20000
	SetWindowLong hWnd, -16, ret

	SetMinWindowSize Parent, 270, 276
	Panel  = CreatePanel(1, 1, 260, 228, Parent, -1)
	Canvas = CreateCanvas(0, 0, 256, 224, Panel)
	SetBuffer CanvasBuffer(Canvas)
	
	; // [Editor Menu]
	Menu = WindowMenu(Parent)
	File = CreateMenu("&File", 0, Menu)
	CreateMenu "&New", cnt_NEW, File
	CreateMenu "&Open", cnt_OPEN, File
	CreateMenu "Sa&ve", cnt_SAVE, File
	CreateMenu "", 0, File
	CreateMenu "E&xit", cnt_EXITED, File
	View = CreateMenu("&View", 0, Menu)
	ViewGrid = CreateMenu("&Grid", cnt_GRID, View)
	CheckMenu ViewGrid
	ViewTile = CreateMenu("Ti&les", cnt_VTILE, View)
	CheckMenu ViewTile
	CreateMenu "", 0, View
	vTileSet = CreateMenu("Tileset", 0, View)
	mnuMario = CreateMenu("Super Mario", cntTIL1, vTileSet)
	CheckMenu mnuMario
	mnuIce = CreateMenu("Metroid", cntTIL2, vTileSet)
	mnuCastle = CreateMenu("Castlevania", cntTIL3, vTileSet)
	CreateMenu "", 0, vTileSet
	CreateMenu("Custom...", cntCUST, vTileSet)
	Online = CreateMenu("&O&nline", 0, Menu)
	CreateMenu "&Upload Map", cnt_UPLOAD, Online
	Help = CreateMenu("&Help", 0, Menu)
	CreateMenu "&Instructions", cnt_INSTR, Help
	UpdateWindowMenu Parent
		
	; // [Gadget Sizing]
	SetGadgetLayout Panel, 2, 1, 2, 1
	SetGadgetLayout Canvas, 2, 1, 2, 1
	SetGadgetShape Parent, -800, 0, 526, 500 
	SetGadgetShape Parent, ClientWidth(Desktop())/2-263, ClientHeight(Desktop())/2-250, 526, 500 
	
	Toolbox = CreateWindow("Tiles", -300, 0, 92, 306, Parent, 1)
	SPanel = CreatePanel(1, 1, 84, 279, Toolbox, -1)
	ed_Canvas = CreateCanvas(0, 0, 80, 275, SPanel)
	ActivateGadget Canvas
	
	; // [Gadget Sizing]
	SetGadgetLayout SPanel, 2, 1, 2, 1
	SetGadgetLayout ed_Canvas, 2, 1, 2, 1
	SetGadgetShape Toolbox, -300, 0, 176, 519
	SetGadgetShape Toolbox, GadgetX(Parent) + 526, GadgetY(Parent), 176, 519
	
ElseIf mode = 3 ; Reload Toolbox
	Toolbox = CreateWindow("Tiles", ClientWidth(Desktop())/2+135, ClientHeight(Desktop())/2-138, 92, 306, Parent, 1)
	SPanel = CreatePanel(1, 1, 84, 279, Toolbox, -1)
	ed_Canvas = CreateCanvas(0, 0, 80, 275, SPanel)
	ActivateGadget Canvas	
	
	; // [Gadget Sizing]
	SetGadgetLayout SPanel, 2, 1, 2, 1
	SetGadgetLayout ed_Canvas, 2, 1, 2, 1
	SetGadgetShape Toolbox, GadgetX(Parent) + 526, GadgetY(Parent), 176, 519

ElseIf mode = 4 Then ; Music Question
	MusicBox = CreateWindow("Music & Background Settings", ClientWidth(Desktop())/2-152, ClientHeight(Desktop())/2-44, 305, 114, Parent, 1)
	Label = CreateLabel("Enter the filename of the music file you wish to attach to this map. The file must be in the Music directory. Ex: music.mid", 5, 5, 290, 28, MusicBox, 0)
	MusicText = CreateTextField(5, 38, 290, 20, MusicBox, 0)
	gad_Clouds = CreateButton("Cloud Background", 5, 62, 110, 20, MusicBox, 2)
	SetButtonState gad_Clouds, True
	gad_SColor = CreateButton("Sky Color", 221, 62, 74, 24, MusicBox, 1)
	SaveBtn = CreateButton("Save", 140, 62, 74, 24, MusicBox, 1)
	ActivateGadget MusicText
	
EndIf
End Function